#include <stdlib.h>
#include "syspro.h"

/* Test for global allocations */

static PetscErrorCode copy
(NumericalProblem problem,void *dum,NumericalSolution *rsol)
{
  NumericalSolution sol; PetscErrorCode ierr;
  PetscFunctionBegin;
  ierr = PetscMalloc(sizeof(int),(int**)&sol); CHKERRQ(ierr);
  *(int*)sol = *(int*)problem;
  *rsol = sol;
  PetscFunctionReturn(0);
}

int main(int argc,char **argv) {
  PetscErrorCode ierr;
  PetscInitialize(&argc,&argv,0,0);
  ierr = SysProInitialize(); CHKERRQ(ierr);
  ierr = SysProDeclareFunctions
    (NULL,NULL,NULL,copy,NULL,NULL,NULL,NULL,NULL,NULL,NULL); CHKERRQ(ierr);
  ierr = SysProFinalize(); CHKERRQ(ierr);
  PetscFinalize();
  return 0;
}
